// Global variables
var gImagePath = "Resources/Images/";
var gBackgroudImage = "Window/theBackground.png";
var gNeedleImage = "needle.png";
var gNeedleHighImage = "needleHigh.png";
var gNeedleLowImage = "needleLow.png";

var gReceivedAverage = new Array();
var gSentAverage = new Array();
var gLastReceivedAverage = 0;
var gLastSentAverage = 0;
var gArraySize = 0;
var gArrayIndex = 0;
var gLastReceivedBytes = 0;
var gLastSentBytes = 0;
var gInterval = 0;
var gMaxReceivedValue = 0;
var gMaxSentValue = 0;


var gSpanAngle = 120;
var gSpanMin = -(gSpanAngle/2);
var gSpanMax = gSpanAngle/2;

// Global Graphics
var gTheBackground = new Image();
var gTheNeedleReceived = new Image();
var gTheNeedleSent = new Image();
var gTheNeedleReceivedLow = new Image();
var gTheNeedleSentLow = new Image();
var gTheNeedleReceivedHigh = new Image();
var gTheNeedleSentHigh = new Image();
//var gTheNeedleTmp = new Image();

// Global Texts
var gReceivedValueText = new Text();
var gSentValueText = new Text();

var gLastReceivedText = new Text();
var gLastSentText = new Text();

var gReceivedMinText = new Text();
var gReceivedMidText = new Text();
var gReceivedMaxText = new Text();
var gSentMinText = new Text();
var gSentMidText = new Text();
var gSentMaxText = new Text();
var gReceivedTitle = new Text();
var gSentTitle = new Text();

var gMeanTextSize = 10;
var gMeanTextColor = "#FFFF80";
var gMeanTextStyle = "condensed, bold";
var gMeanTextAlignment = "center";
var gMeanTextFont = "Verdana, Arial";

var gMinTextSize = 7;
var gMinTextColor = "#DCFF71";
var gMinTextStyle = "condensed, bold";
var gMinTextAlignment = "center";
var gMinTextFont = "Verdana, Arial";

var gReceivedTitleColor = "#DF0000";
var gSentTitleColor = "#00C600";
var gTitleSize = 8;
var gTitleStyle = "bold";

// Start Widget
doLoadWidget();


function doLoadWidget()
{
  print("doLoadWidget()");
  doInitWidgetValues();
  doInitImages();
  doInitTexts();

  doRefresh();
}

function doInitWidgetValues()
{
  print("doInitWidgetValues()");
  //Init array size
  gArraySize = parseInt(preferences.span.value);
  gInterval = parseInt(preferences.interval.value);
  gMaxReceivedValue = parseInt(preferences.maxReceivedValue.value);
  //print("gMaxReceivedValue = " + gMaxReceivedValue);
  gMaxSentValue = parseInt(preferences.maxSentValue.value);
  //print("gMaxSentValue = " + gMaxSentValue);
  
  print("gArraySize = " + gArraySize);
  print("gInterval = " + gInterval);
  print("gMaxReceivedValue = " + Bbeautify_bytes(gMaxReceivedValue));
  print("gMaxSentValue = " + Bbeautify_bytes(gMaxSentValue));
  
  doInitTexts();
  
  //Init Array
  for(i=0; i<gArraySize; i++)
  {
    gReceivedAverage[i] = 0;
    gSentAverage[i] = 0;
  }
  
  //Starts the update timer
  print("start timer");
  updateTimer = new Timer();
  updateTimer.interval = gInterval;
  updateTimer.ticking = 1;
  updateTimer.onTimerFired = "doRefresh();";
}

function doInitImages()
{
  print("doInitImages()");
  gTheBackground.src=gImagePath+gBackgroudImage;
  //gTheBackground.width = 170;//150
  //gTheBackground.height = 70;//100
  gTheBackground.hOffset = 0;
  gTheBackground.vOffset = 0;
  gTheBackground.opacity = 255;
  
  gTheNeedleReceivedHigh.src=gImagePath+gNeedleHighImage;
  gTheNeedleReceivedHigh.width = 2;
  gTheNeedleReceivedHigh.height = 34;
  gTheNeedleReceivedHigh.vOffset = 40;
  gTheNeedleReceivedHigh.opacity = 255;
  gTheNeedleReceivedHigh.hRegistrationPoint = 1;
  gTheNeedleReceivedHigh.vRegistrationPoint = 28;
  gTheNeedleReceivedHigh.rotation = gSpanMax;
  gTheNeedleReceivedHigh.hOffset = 53;
  
  gTheNeedleReceivedLow.src=gImagePath+gNeedleLowImage;
  gTheNeedleReceivedLow.width = 2;
  gTheNeedleReceivedLow.height = 34;
  gTheNeedleReceivedLow.vOffset = 40;
  gTheNeedleReceivedLow.opacity = 255;
  gTheNeedleReceivedLow.hRegistrationPoint = 1;
  gTheNeedleReceivedLow.vRegistrationPoint = 28;
  gTheNeedleReceivedLow.rotation = gSpanMin;
  gTheNeedleReceivedLow.hOffset = 53;
  
  gTheNeedleReceived.src=gImagePath+gNeedleImage;
  gTheNeedleReceived.width = 14;
  gTheNeedleReceived.height = 34;
  gTheNeedleReceived.vOffset = 40;
  gTheNeedleReceived.opacity = 255;
  gTheNeedleReceived.hRegistrationPoint = 7;
  gTheNeedleReceived.vRegistrationPoint = 28;
  gTheNeedleReceived.rotation = gSpanMin;
  gTheNeedleReceived.hOffset = 47;
  
  
  gTheNeedleSent.src=gImagePath+gNeedleImage;
  gTheNeedleSent.width = gTheNeedleReceived.width;
  gTheNeedleSent.height = gTheNeedleReceived.height;
  gTheNeedleSent.vOffset = gTheNeedleReceived.vOffset;
  gTheNeedleSent.opacity = gTheNeedleReceived.opacity;
  gTheNeedleSent.hRegistrationPoint = gTheNeedleReceived.hRegistrationPoint;
  gTheNeedleSent.vRegistrationPoint = gTheNeedleReceived.vRegistrationPoint;
  gTheNeedleSent.rotation = gSpanMin;
  gTheNeedleSent.hOffset = 125;//110
  
} // doInitImages()

function doInitTexts()
{
  print("doInitTexts()");
  gReceivedValueText.data = "0";
  gReceivedValueText.alignment = gMeanTextAlignment;
  gReceivedValueText.hOffset = 47;
  gReceivedValueText.vOffset = 57;
  gReceivedValueText.color = gMeanTextColor;
  gReceivedValueText.style = gMeanTextStyle;
  gReceivedValueText.size = gMeanTextSize;
  gReceivedValueText.font = gMeanTextFont;
  
  gLastReceivedText.data = "0";                    
  gLastReceivedText.alignment = gMeanTextAlignment;
  gLastReceivedText.hOffset = 47;                  
  gLastReceivedText.vOffset = 67;                  
  gLastReceivedText.color = "#CECE00";        
  gLastReceivedText.style = gMeanTextStyle;        
  gLastReceivedText.size = 8;          
  gLastReceivedText.font = gMeanTextFont;      
  
  gLastSentText.data = "0";                    
  gLastSentText.alignment = gMeanTextAlignment;
  gLastSentText.hOffset = 125;                  
  gLastSentText.vOffset = 67;                  
  gLastSentText.color = gLastReceivedText.color;        
  gLastSentText.style = gMeanTextStyle;        
  gLastSentText.size = 8;          
  gLastSentText.font = gMeanTextFont;     
  
  gSentValueText.data = "0";//Bbeautify_bytes(gLastSentAverage);
  gSentValueText.alignment = gMeanTextAlignment;
  gSentValueText.hOffset = 125;
  gSentValueText.vOffset = gReceivedValueText.vOffset;
  gSentValueText.color = gMeanTextColor;
  gSentValueText.style = gMeanTextStyle;
  gSentValueText.size = gMeanTextSize;
  gSentValueText.font = gMeanTextFont;
  
  gReceivedMinText.data = "0";
  gReceivedMinText.alignment = "right";
  gReceivedMinText.color = gMinTextColor;
  gReceivedMinText.style = gMinTextStyle;
  gReceivedMinText.size = gMinTextSize;
  gReceivedMinText.font = gMinTextFont;
  gReceivedMinText.hOffset = 20;
  gReceivedMinText.vOffset = 26;
  
  gReceivedMaxText.data = Bbeautify_bytes_max(gMaxReceivedValue);
  gReceivedMaxText.alignment = "left";
  gReceivedMaxText.color = gMinTextColor;
  gReceivedMaxText.style = gMinTextStyle;
  gReceivedMaxText.size = gMinTextSize;
  gReceivedMaxText.font = gMinTextFont;
  gReceivedMaxText.hOffset = 71;
  gReceivedMaxText.vOffset = gReceivedMinText.vOffset;
  
  
  gSentMinText.data = "0";
  gSentMinText.alignment = "right";
  gSentMinText.color = gMinTextColor;
  gSentMinText.style = gMinTextStyle;
  gSentMinText.size = gMinTextSize;
  gSentMinText.font = gMinTextFont;
  gSentMinText.hOffset = 101;
  gSentMinText.vOffset = gReceivedMinText.vOffset;
  
  gSentMaxText.data = Bbeautify_bytes_max(gMaxSentValue);
  gSentMaxText.alignment = "left";
  gSentMaxText.color = gMinTextColor;
  gSentMaxText.style = gMinTextStyle;
  gSentMaxText.size = gMinTextSize;
  gSentMaxText.font = gMinTextFont;
  gSentMaxText.hOffset = 151;
  gSentMaxText.vOffset = gReceivedMinText.vOffset;
  
  gReceivedTitle.data = "Down";
  gReceivedTitle.alignment = "center";                
  gReceivedTitle.color = gReceivedTitleColor;             
  gReceivedTitle.style = gTitleStyle;             
  gReceivedTitle.size = gTitleSize;               
  gReceivedTitle.font = gMinTextFont;               
  gReceivedTitle.hOffset = 45;                     
  gReceivedTitle.vOffset = 10;
  
  gSentTitle.data = "up";
  gSentTitle.alignment = "center";                
  gSentTitle.color = gSentTitleColor;             
  gSentTitle.style = gTitleStyle;             
  gSentTitle.size = gTitleSize;               
  gSentTitle.font = gMinTextFont;               
  gSentTitle.hOffset = 125;                     
  gSentTitle.vOffset = gReceivedTitle.vOffset;
  
} // doInitTexts()

function doRefresh()
{
  print("doRefresh()");
  var result = new Array();
  output=runCommand("netstat -e");
  result = doParseNetstatOutput(output);
  
  if(gLastReceivedBytes != 0)
  {
    var tmp = Math.round((result[0] - gLastReceivedBytes)/gInterval);
    gReceivedAverage[gArrayIndex] = tmp;
  }
  gLastReceivedBytes = result[0];
  
  if(gLastSentBytes != 0)
  {
    var tmp = Math.round((result[1] - gLastSentBytes)/gInterval);
    gSentAverage[gArrayIndex] = tmp;
  }
  gLastSentBytes = result[1];
  
  var gCurrentReceivedSum = 0;
  var gCurrentSentSum = 0;
  var k = gArrayIndex;
  var kSum=0;
  var ponderation = gArraySize;
  
  print("gReceivedAverage[" + k + "] = " + gReceivedAverage[k]);
  print("gReceivedAverage[k] * (i+1) =");
  
  for(i=gArraySize-1; i>=0; i--)
  {
    //print("gReceivedAverage[" + i + "]: "+ gReceivedAverage[i] + " B/s");
    //print("gSentAverage[" + i + "]:     "+ gSentAverage[i] + " B/s");
    gCurrentReceivedSum += gReceivedAverage[k]*(ponderation);
    gCurrentSentSum += gSentAverage[k]*(ponderation);
    print("gReceivedAverage["+k+"] * "+(ponderation) + " = " + gReceivedAverage[k] + " * " + (ponderation));
    kSum+=i+1;
    if(ponderation+1 < gArraySize)
    {
      ponderation++;
    }
    else
    {
      ponderation = 1;
    } 
    if(k+1 < gArraySize)
    {
      k++;
    }
    else
    {
      k = 0;
    }
  }
  //print("--");
  
  if(gArrayIndex+1 < gArraySize)
  {
    gArrayIndex++;
  }
  else
  {
    gArrayIndex = 0;
  }
  var currentReceivedAverage = Math.round(gCurrentReceivedSum/kSum);
  print("kSum = " + kSum);
  print("currentReceivedAverage = " + currentReceivedAverage + " B/s");
  
  gLastReceivedAverage = currentReceivedAverage;
  
  var receivedAngle = doCalculateReceiveAngle(gLastReceivedAverage);
  gReceivedValueText.data = Bbeautify_bytes(gLastReceivedAverage);
  gLastReceivedText.data = Bbeautify_bytes(gReceivedAverage[k]);
  
  var currentSentAverage = Math.round(gCurrentSentSum/kSum);
  //print("gCurrentSum = " + gCurrentSentSum + " B/s");
  //print("currentSentAverage = " + currentSentAverage + " B/s");
  
  gLastSentAverage = currentSentAverage;
  
  var SentAngle = doCalculateSentAngle(gLastSentAverage);
  doRotateNeedles(receivedAngle,SentAngle);
  gSentValueText.data = Bbeautify_bytes(gLastSentAverage);
  gLastSentText.data = Bbeautify_bytes(gSentAverage[k]);
} // doRefresh()

function doCalculateReceiveAngle(xValue)
{
  var retVal = gSpanMin + Math.round(xValue / gMaxReceivedValue * gSpanAngle);
  if(retVal > gSpanMax)
  {
    retVal = gSpanMax;
  }
  //print("Angle value = " + retVal + "");
  return retVal;
}

function doCalculateSentAngle(xValue)
{
  var retVal = gSpanMin + Math.round(xValue / gMaxSentValue * gSpanAngle);
  if(retVal > gSpanMax)
  {
    retVal = gSpanMax;
  }
  //print("Angle value = " + retVal + "");
  return retVal;
}

function doParseNetstatOutput(output)
{
  //print("doParseNetstatOutput()");
  var lines=output.split("\n");
  var tmpRegExp = /([\d]+)\s*([\d]+)/;
  var tmpString = tmpRegExp.exec(lines[4]);
  var result = new Array();
  result[0] = tmpString[1];
  result[1] = tmpString[2];
  return result;
}

function Bbeautify_bytes ( bytes )
{
	types=new Array( 'B/s', 'kB/s', 'MB/s', 'GB/s', 'TB/s', 'PB/s' );
	count=0;
	while ( bytes > 1000 ) {
		bytes=parseFloat(bytes / 1000);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + " " + types[count];
	return output;
}


function Bbeautify_bytes_max ( bytes )
{
	types=new Array( 'B', 'K', 'M', 'G', 'T', 'P' );
	count=0;
	while ( bytes > 1000 ) {
		bytes=parseFloat(bytes / 1000);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + types[count];
	return output;
}

function bbeautify_bytes ( bytes )
{
	bytes = bytes * 8;
	types=new Array( 'b/s', 'kb/s', 'Mb/s', 'Gb/s', 'Tb/s', 'Pb/s' );
	count=0;
	while ( bytes > 1024 ) {
		bytes=parseFloat(bytes / 1024);
		count++;
	}
	output=(Math.round(bytes * 10) / 10) + " " + types[count];
	return output;
}

function doRotateNeedles(xReceivedAngle, xSentAngle)
{
  var receiveNeedle = new RotateAnimation(gTheNeedleReceived, xReceivedAngle, gInterval*1000, animator.kEaseInOut);
  
  var sentNeedle = new RotateAnimation(gTheNeedleSent, xSentAngle, gInterval*1000, animator.kEaseInOut);
  animator.start(receiveNeedle);
  animator.start(sentNeedle);
}